#ifndef Models_H
#define Models_H

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/* function prototypes */

#define nmax 20

float implied_vol(s,x,r,t,c,div,tdiv)
/* Use bisection method to find volatility */
float s,x,r,t,c,div,tdiv;
{
  float v1,v2,v0,vmid,fmid,dv,f,sdiv;
  int i;

  sdiv = s - div*exp(-r*tdiv);
  v1 = 0.0000006; v2 = 1.2;
  fmid = (bscall(sdiv,x,r,t,v2) - c);
  f = (bscall(sdiv,x,r,t,v1) - c);
  if (f*fmid >= 0.0) {
    /* fprintf(stderr,"implied_vol: root not bracketed at %i\n",count);*/
    return(-1.0);
  }

  if (f < 0.0) {
    v0 = v1;
    dv = v2 - v1;
  }
  else {
    v0 = v2;
    dv = v1 - v2;
  }
  for (i = 0; i < nmax; i++) {
    dv = dv/2.0;
    vmid = v0 + dv;
    fmid = (bscall(sdiv,x,r,t,vmid) - c);
    if (fmid < 0.0) v0 = vmid;
  }

  return(v0);
}

#endif Models_H
